SDL_cpuinfo.c File Reference
`#include "../SDL_internal.h"`
`#include "SDL_cpuinfo.h"`
Include dependency graph for SDL_cpuinfo.c:

Go to the source code of this file.

## Macros

#define | CPU_HAS_RDTSC 0x00000001
#define | CPU_HAS_ALTIVEC 0x00000002
#define | CPU_HAS_MMX 0x00000004
#define | CPU_HAS_3DNOW 0x00000008
#define | CPU_HAS_SSE 0x00000010
#define | CPU_HAS_SSE2 0x00000020
#define | CPU_HAS_SSE3 0x00000040
#define | CPU_HAS_SSE41 0x00000100
#define | CPU_HAS_SSE42 0x00000200
#define | CPU_HAS_AVX 0x00000400
#define | CPU_HAS_AVX2 0x00000800
#define | CPU_HAS_NEON 0x00001000
#define | cpuid(func, a, b, c, d) do { a = b = c = d = 0; (void) a; (void) b; (void) c; (void) d; } while (0)
#define | CPU_haveRDTSC() (CPU_CPUIDFeatures[3] & 0x00000010)
#define | CPU_haveMMX() (CPU_CPUIDFeatures[3] & 0x00800000)
#define | CPU_haveSSE() (CPU_CPUIDFeatures[3] & 0x02000000)
#define | CPU_haveSSE2() (CPU_CPUIDFeatures[3] & 0x04000000)
#define | CPU_haveSSE3() (CPU_CPUIDFeatures[2] & 0x00000001)
#define | CPU_haveSSE41() (CPU_CPUIDFeatures[2] & 0x00080000)
#define | CPU_haveSSE42() (CPU_CPUIDFeatures[2] & 0x00100000)
#define | CPU_haveAVX() (CPU_OSSavesYMM && (CPU_CPUIDFeatures[2] & 0x10000000))
#define | CPU_FEATURE_AVAILABLE(f) ((SDL_GetCPUFeatures() & f) ? SDL_TRUE : SDL_FALSE)

## Functions

static int | CPU_haveCPUID (void)
static void | CPU_calcCPUIDFeatures (void)
static int | CPU_haveAltiVec (void)
static int | CPU_haveNEON (void)
static int | CPU_have3DNow (void)
static int | CPU_haveAVX2 (void)
int | SDL_GetCPUCount (void)
static const char * | SDL_GetCPUType (void)
int | SDL_GetCPUCacheLineSize (void)
static Uint32 | SDL_GetCPUFeatures (void)
SDL_bool | SDL_HasRDTSC (void)
SDL_bool | SDL_HasAltiVec (void)
SDL_bool | SDL_HasMMX (void)
SDL_bool | SDL_Has3DNow (void)
SDL_bool | SDL_HasSSE (void)
SDL_bool | SDL_HasSSE2 (void)
SDL_bool | SDL_HasSSE3 (void)
SDL_bool | SDL_HasSSE41 (void)
SDL_bool | SDL_HasSSE42 (void)
SDL_bool | SDL_HasAVX (void)
SDL_bool | SDL_HasAVX2 (void)
SDL_bool | SDL_HasNEON (void)
int | SDL_GetSystemRAM (void)

## Variables

static int | CPU_CPUIDFeatures [4]
static int | CPU_CPUIDMaxFunction = 0
static SDL_bool | CPU_OSSavesYMM = SDL_FALSE
static int | SDL_CPUCount = 0
static Uint32 | SDL_CPUFeatures = 0xFFFFFFFF
static int | SDL_SystemRAM = 0

## Macro Definition Documentation

## CPU_FEATURE_AVAILABLE

#define CPU_FEATURE_AVAILABLE | ( |  | f | ) | ((SDL_GetCPUFeatures() & f) ? SDL_TRUE : SDL_FALSE)

Definition at line 621 of file SDL_cpuinfo.c.

Referenced by SDL_Has3DNow(), SDL_HasAltiVec(), SDL_HasAVX(), SDL_HasAVX2(), SDL_HasMMX(), SDL_HasNEON(), SDL_HasRDTSC(), SDL_HasSSE(), SDL_HasSSE2(), SDL_HasSSE3(), SDL_HasSSE41(), and SDL_HasSSE42().

## CPU_HAS_3DNOW

#define CPU_HAS_3DNOW 0x00000008

Definition at line 82 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures(), and SDL_Has3DNow().

## CPU_HAS_ALTIVEC

#define CPU_HAS_ALTIVEC 0x00000002

Definition at line 80 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures(), and SDL_HasAltiVec().

## CPU_HAS_AVX

#define CPU_HAS_AVX 0x00000400

Definition at line 88 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures(), and SDL_HasAVX().

## CPU_HAS_AVX2

#define CPU_HAS_AVX2 0x00000800

Definition at line 89 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures(), and SDL_HasAVX2().

## CPU_HAS_MMX

#define CPU_HAS_MMX 0x00000004

Definition at line 81 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures(), and SDL_HasMMX().

## CPU_HAS_NEON

#define CPU_HAS_NEON 0x00001000

Definition at line 90 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures(), and SDL_HasNEON().

## CPU_HAS_RDTSC

#define CPU_HAS_RDTSC 0x00000001

Definition at line 79 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures(), and SDL_HasRDTSC().

## CPU_HAS_SSE

#define CPU_HAS_SSE 0x00000010

Definition at line 83 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures(), and SDL_HasSSE().

## CPU_HAS_SSE2

#define CPU_HAS_SSE2 0x00000020

Definition at line 84 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures(), and SDL_HasSSE2().

## CPU_HAS_SSE3

#define CPU_HAS_SSE3 0x00000040

Definition at line 85 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures(), and SDL_HasSSE3().

## CPU_HAS_SSE41

#define CPU_HAS_SSE41 0x00000100

Definition at line 86 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures(), and SDL_HasSSE41().

## CPU_HAS_SSE42

#define CPU_HAS_SSE42 0x00000200

Definition at line 87 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures(), and SDL_HasSSE42().

## CPU_haveAVX

#define CPU_haveAVX | ( |  | ) | (CPU_OSSavesYMM && (CPU_CPUIDFeatures[2] & 0x10000000))

Definition at line 389 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures().

## CPU_haveMMX

#define CPU_haveMMX | ( |  | ) | (CPU_CPUIDFeatures[3] & 0x00800000)

Definition at line 383 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures().

## CPU_haveRDTSC

#define CPU_haveRDTSC | ( |  | ) | (CPU_CPUIDFeatures[3] & 0x00000010)

Definition at line 382 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures().

## CPU_haveSSE

#define CPU_haveSSE | ( |  | ) | (CPU_CPUIDFeatures[3] & 0x02000000)

Definition at line 384 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures().

## CPU_haveSSE2

#define CPU_haveSSE2 | ( |  | ) | (CPU_CPUIDFeatures[3] & 0x04000000)

Definition at line 385 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures().

## CPU_haveSSE3

#define CPU_haveSSE3 | ( |  | ) | (CPU_CPUIDFeatures[2] & 0x00000001)

Definition at line 386 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures().

## CPU_haveSSE41

#define CPU_haveSSE41 | ( |  | ) | (CPU_CPUIDFeatures[2] & 0x00080000)

Definition at line 387 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures().

## CPU_haveSSE42

#define CPU_haveSSE42 | ( |  | ) | (CPU_CPUIDFeatures[2] & 0x00100000)

Definition at line 388 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures().

## cpuid

#define cpuid | ( |  | func,
|  |  | a,
|  |  | b,
|  |  | c,
|  |  | d
| ) |  | do { a = b = c = d = 0; (void) a; (void) b; (void) c; (void) d; } while (0)

Definition at line 242 of file SDL_cpuinfo.c.

Referenced by CPU_calcCPUIDFeatures(), CPU_have3DNow(), CPU_haveAVX2(), SDL_GetCPUCacheLineSize(), and SDL_GetCPUType().

## Function Documentation

## CPU_calcCPUIDFeatures()

static void CPU_calcCPUIDFeatures | ( | void |  | ) |

static

Definition at line 251 of file SDL_cpuinfo.c.

References CPU_CPUIDFeatures, CPU_CPUIDMaxFunction, CPU_haveCPUID(), CPU_OSSavesYMM, cpuid, d, SDL_FALSE, and SDL_TRUE.

Referenced by SDL_GetCPUFeatures(), and SDL_GetCPUType().

{
static SDL_bool checked = SDL_FALSE;
if (!checked) {
checked = SDL_TRUE;
if (CPU_haveCPUID()) {
int a, b, c, d;
cpuid(0, a, b, c, d);
CPU_CPUIDMaxFunction = a;
if (CPU_CPUIDMaxFunction >= 1) {
cpuid(1, a, b, c, d);
CPU_CPUIDFeatures[0] = a;
CPU_CPUIDFeatures[1] = b;
CPU_CPUIDFeatures[2] = c;
CPU_CPUIDFeatures[3] = d;
/* Check to make sure we can call xgetbv */
if (c & 0x08000000) {
/* Call xgetbv to see if YMM register state is saved */
#if defined(__GNUC__) && (defined(i386) || defined(__x86_64__))
__asm__(".byte 0x0f, 0x01, 0xd0" : "=a" (a) : "c" (0) : "%edx");
#elif defined(_MSC_VER) && (defined(_M_IX86) || defined(_M_X64)) && (_MSC_FULL_VER >= 160040219) /* VS2010 SP1 */
a = (int)_xgetbv(0);
#elif (defined(_MSC_VER) && defined(_M_IX86)) || defined(__WATCOMC__)
__asm
{
xor ecx, ecx
_asm _emit 0x0f _asm _emit 0x01 _asm _emit 0xd0
mov a, eax
}
#endif
CPU_OSSavesYMM = ((a & 6) == 6) ? SDL_TRUE : SDL_FALSE;
}
}
}
}
}
CPU_OSSavesYMM
static SDL_bool CPU_OSSavesYMM
Definition: SDL_cpuinfo.c:248
SDL_TRUE
Definition: SDL_stdinc.h:142
SDL_FALSE
Definition: SDL_stdinc.h:141
CPU_CPUIDMaxFunction
static int CPU_CPUIDMaxFunction
Definition: SDL_cpuinfo.c:247
CPU_haveCPUID
static int CPU_haveCPUID(void)
Definition: SDL_cpuinfo.c:105
d
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 SDL_AssertionHandler void SDL_SpinLock SDL_atomic_t int int return SDL_atomic_t return void void void return void return int return SDL_AudioSpec SDL_AudioSpec return int int return return int SDL_RWops int SDL_AudioSpec Uint8 ** d
Definition: SDL_dynapi_procs.h:117
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
cpuid
#define cpuid(func, a, b, c, d)
Definition: SDL_cpuinfo.c:242
SDL_bool
SDL_bool
Definition: SDL_stdinc.h:139
CPU_CPUIDFeatures
static int CPU_CPUIDFeatures[4]
Definition: SDL_cpuinfo.c:246
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
b
GLboolean GLboolean GLboolean b
Definition: SDL_opengl_glext.h:1109

## CPU_have3DNow()

static int CPU_have3DNow | ( | void |  | ) |

static

Definition at line 369 of file SDL_cpuinfo.c.

References CPU_CPUIDMaxFunction, cpuid, and d.

Referenced by SDL_GetCPUFeatures().

{
if (CPU_CPUIDMaxFunction > 0) { /* that is, do we have CPUID at all? */
int a, b, c, d;
cpuid(0x80000000, a, b, c, d);
if (a >= 0x80000001) {
cpuid(0x80000001, a, b, c, d);
return (d & 0x80000000);
}
}
return 0;
}
CPU_CPUIDMaxFunction
static int CPU_CPUIDMaxFunction
Definition: SDL_cpuinfo.c:247
d
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 SDL_AssertionHandler void SDL_SpinLock SDL_atomic_t int int return SDL_atomic_t return void void void return void return int return SDL_AudioSpec SDL_AudioSpec return int int return return int SDL_RWops int SDL_AudioSpec Uint8 ** d
Definition: SDL_dynapi_procs.h:117
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
cpuid
#define cpuid(func, a, b, c, d)
Definition: SDL_cpuinfo.c:242
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
b
GLboolean GLboolean GLboolean b
Definition: SDL_opengl_glext.h:1109

## CPU_haveAltiVec()

static int CPU_haveAltiVec | ( | void |  | ) |

static

Definition at line 290 of file SDL_cpuinfo.c.

References NULL, and void.

Referenced by SDL_GetCPUFeatures().

{
volatile int altivec = 0;
#ifndef SDL_CPUINFO_DISABLED
#if (defined(__MACOSX__) && (defined(__ppc__) || defined(__ppc64__))) || (defined(__OpenBSD__) && defined(__powerpc__))
#ifdef __OpenBSD__
int selectors[2] = { CTL_MACHDEP, CPU_ALTIVEC };
#else
int selectors[2] = { CTL_HW, HW_VECTORUNIT };
#endif
int hasVectorUnit = 0;
size_t length = sizeof(hasVectorUnit);
int error = sysctl(selectors, 2, &hasVectorUnit, &length, NULL, 0);
if (0 == error)
altivec = (hasVectorUnit != 0);
#elif SDL_ALTIVEC_BLITTERS && HAVE_SETJMP
void (*handler) (int sig);
handler = signal(SIGILL, illegal_instruction);
if (setjmp(jmpbuf) == 0) {
asm volatile ("mtspr 256, %0\n\t" "vand %%v0, %%v0, %%v0"::"r" (-1));
altivec = 1;
}
signal(SIGILL, handler);
#endif
#endif
return altivec;
}
NULL
#define NULL
Definition: begin_code.h:164
void
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 void
Definition: SDL_dynapi_procs.h:89
length
GLuint GLsizei GLsizei * length
Definition: SDL_opengl_glext.h:669

## CPU_haveAVX2()

static int CPU_haveAVX2 | ( | void |  | ) |

static

Definition at line 392 of file SDL_cpuinfo.c.

References CPU_CPUIDMaxFunction, CPU_OSSavesYMM, cpuid, d, and void.

Referenced by SDL_GetCPUFeatures().

{
if (CPU_OSSavesYMM && (CPU_CPUIDMaxFunction >= 7)) {
int a, b, c, d;
(void) a; (void) b; (void) c; (void) d; /* compiler warnings... */
cpuid(7, a, b, c, d);
return (b & 0x00000020);
}
return 0;
}
CPU_OSSavesYMM
static SDL_bool CPU_OSSavesYMM
Definition: SDL_cpuinfo.c:248
CPU_CPUIDMaxFunction
static int CPU_CPUIDMaxFunction
Definition: SDL_cpuinfo.c:247
d
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 SDL_AssertionHandler void SDL_SpinLock SDL_atomic_t int int return SDL_atomic_t return void void void return void return int return SDL_AudioSpec SDL_AudioSpec return int int return return int SDL_RWops int SDL_AudioSpec Uint8 ** d
Definition: SDL_dynapi_procs.h:117
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
cpuid
#define cpuid(func, a, b, c, d)
Definition: SDL_cpuinfo.c:242
void
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 void
Definition: SDL_dynapi_procs.h:89
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
b
GLboolean GLboolean GLboolean b
Definition: SDL_opengl_glext.h:1109

## CPU_haveCPUID()

static int CPU_haveCPUID | ( | void |  | ) |

static

Definition at line 105 of file SDL_cpuinfo.c.

References done, and pop.

Referenced by CPU_calcCPUIDFeatures().

{
int has_CPUID = 0;
/* *INDENT-OFF* */
#ifndef SDL_CPUINFO_DISABLED
#if defined(__GNUC__) && defined(i386)
__asm__ (
" pushfl # Get original EFLAGS \n"
" popl %%eax \n"
" movl %%eax,%%ecx \n"
" xorl $0x200000,%%eax # Flip ID bit in EFLAGS \n"
" pushl %%eax # Save new EFLAGS value on stack \n"
" popfl # Replace current EFLAGS value \n"
" pushfl # Get new EFLAGS \n"
" popl %%eax # Store new EFLAGS in EAX \n"
" xorl %%ecx,%%eax # Can not toggle ID bit, \n"
" jz 1f # Processor=80486 \n"
" movl $1,%0 # We have CPUID support \n"
"1: \n"
: "=m" (has_CPUID)
:
: "%eax", "%ecx"
);
#elif defined(__GNUC__) && defined(__x86_64__)
/* Technically, if this is being compiled under __x86_64__ then it has
CPUid by definition. But it's nice to be able to prove it. :) */
__asm__ (
" pushfq # Get original EFLAGS \n"
" popq %%rax \n"
" movq %%rax,%%rcx \n"
" xorl $0x200000,%%eax # Flip ID bit in EFLAGS \n"
" pushq %%rax # Save new EFLAGS value on stack \n"
" popfq # Replace current EFLAGS value \n"
" pushfq # Get new EFLAGS \n"
" popq %%rax # Store new EFLAGS in EAX \n"
" xorl %%ecx,%%eax # Can not toggle ID bit, \n"
" jz 1f # Processor=80486 \n"
" movl $1,%0 # We have CPUID support \n"
"1: \n"
: "=m" (has_CPUID)
:
: "%rax", "%rcx"
);
#elif (defined(_MSC_VER) && defined(_M_IX86)) || defined(__WATCOMC__)
__asm {
pushfd ; Get original EFLAGS
pop eax
mov ecx, eax
xor eax, 200000h ; Flip ID bit in EFLAGS
push eax ; Save new EFLAGS value on stack
popfd ; Replace current EFLAGS value
pushfd ; Get new EFLAGS
pop eax ; Store new EFLAGS in EAX
xor eax, ecx ; Can not toggle ID bit,
jz done ; Processor=80486
mov has_CPUID,1 ; We have CPUID support
done:
}
#elif defined(_MSC_VER) && defined(_M_X64)
has_CPUID = 1;
#elif defined(__sun) && defined(__i386)
__asm (
" pushfl \n"
" popl %eax \n"
" movl %eax,%ecx \n"
" xorl $0x200000,%eax \n"
" pushl %eax \n"
" popfl \n"
" pushfl \n"
" popl %eax \n"
" xorl %ecx,%eax \n"
" jz 1f \n"
" movl $1,-8(%ebp) \n"
"1: \n"
);
#elif defined(__sun) && defined(__amd64)
__asm (
" pushfq \n"
" popq %rax \n"
" movq %rax,%rcx \n"
" xorl $0x200000,%eax \n"
" pushq %rax \n"
" popfq \n"
" pushfq \n"
" popq %rax \n"
" xorl %ecx,%eax \n"
" jz 1f \n"
" movl $1,-8(%rbp) \n"
"1: \n"
);
#endif
#endif
/* *INDENT-ON* */
return has_CPUID;
}
h
GLfloat GLfloat GLfloat GLfloat h
Definition: SDL_opengl_glext.h:1946
pop
#define pop
Definition: SDL_qsort.c:192
done
int done
Definition: checkkeys.c:28
value
GLsizei const GLfloat * value
Definition: SDL_opengl_glext.h:698
in
GLuint in
Definition: SDL_opengl_glext.h:7940

## CPU_haveNEON()

static int CPU_haveNEON | ( | void |  | ) |

static

Definition at line 340 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures().

{
/* The way you detect NEON is a privileged instruction on ARM, so you have
query the OS kernel in a platform-specific way. :/ */
#if defined(SDL_CPUINFO_DISABLED) || !defined(__ARM_ARCH)
return 0; /* disabled or not an ARM CPU at all. */
#elif __ARM_ARCH >= 8
return 1; /* ARMv8 always has non-optional NEON support. */
#elif defined(__APPLE__) && (__ARM_ARCH >= 7)
/* (note that sysctlbyname("hw.optional.neon") doesn't work!) */
return 1; /* all Apple ARMv7 chips and later have NEON. */
#elif defined(__APPLE__)
return 0; /* assume anything else from Apple doesn't have NEON. */
#elif defined(__QNXNTO__)
return SYSPAGE_ENTRY(cpuinfo)->flags & ARM_CPU_FLAG_NEON;
#elif (defined(__LINUX__) || defined(__ANDROID__)) && defined(HAVE_GETAUXVAL)
return ((getauxval(AT_HWCAP) & HWCAP_NEON) == HWCAP_NEON);
#elif (defined(__LINUX__) || defined(__ANDROID__))
return readProcAuxvForNeon(); /* Android offers a static library for this, but it just parses /proc/self/auxv */
#elif (defined(__WINDOWS__) || defined(__WINRT__)) && defined(_M_ARM)
/* All WinRT ARM devices are required to support NEON, but just in case. */
return IsProcessorFeaturePresent(PF_ARM_NEON_INSTRUCTIONS_AVAILABLE) != 0;
#else
#warning SDL_HasNEON is not implemented for this ARM platform. Write me.
return 0;
#endif
}

## SDL_GetCPUCacheLineSize()

int SDL_GetCPUCacheLineSize | ( | void |  | ) |

This function returns the L1 cache line size of the CPU

This is useful for determining multi-threaded structure padding or SIMD prefetch sizes.

Definition at line 556 of file SDL_cpuinfo.c.

References cpuid, d, SDL_CACHELINE_SIZE, SDL_GetCPUType(), SDL_strcmp, and void.

Referenced by SDL_GetSystemRAM().

{
const char *cpuType = SDL_GetCPUType();
int a, b, c, d;
(void) a; (void) b; (void) c; (void) d;
if (SDL_strcmp(cpuType, "GenuineIntel") == 0) {
cpuid(0x00000001, a, b, c, d);
return (((b >> 8) & 0xff) * 8);
} else if (SDL_strcmp(cpuType, "AuthenticAMD") == 0) {
cpuid(0x80000005, a, b, c, d);
return (c & 0xff);
} else {
/* Just make a guess here... */
return SDL_CACHELINE_SIZE;
}
}
SDL_GetCPUType
static const char * SDL_GetCPUType(void)
Definition: SDL_cpuinfo.c:445
d
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 SDL_AssertionHandler void SDL_SpinLock SDL_atomic_t int int return SDL_atomic_t return void void void return void return int return SDL_AudioSpec SDL_AudioSpec return int int return return int SDL_RWops int SDL_AudioSpec Uint8 ** d
Definition: SDL_dynapi_procs.h:117
SDL_CACHELINE_SIZE
#define SDL_CACHELINE_SIZE
Definition: SDL_cpuinfo.h:92
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
cpuid
#define cpuid(func, a, b, c, d)
Definition: SDL_cpuinfo.c:242
void
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 void
Definition: SDL_dynapi_procs.h:89
SDL_strcmp
#define SDL_strcmp
Definition: SDL_dynapi_overrides.h:417
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
b
GLboolean GLboolean GLboolean b
Definition: SDL_opengl_glext.h:1109

## SDL_GetCPUCount()

int SDL_GetCPUCount | ( | void |  | ) |

This function returns the number of CPU cores available.

Definition at line 406 of file SDL_cpuinfo.c.

References NULL, and SDL_CPUCount.

Referenced by SDL_GetSystemRAM().

{
if (!SDL_CPUCount) {
#ifndef SDL_CPUINFO_DISABLED
#if defined(HAVE_SYSCONF) && defined(_SC_NPROCESSORS_ONLN)
if (SDL_CPUCount <= 0) {
SDL_CPUCount = (int)sysconf(_SC_NPROCESSORS_ONLN);
}
#endif
#ifdef HAVE_SYSCTLBYNAME
if (SDL_CPUCount <= 0) {
size_t size = sizeof(SDL_CPUCount);
sysctlbyname("hw.ncpu", &SDL_CPUCount, &size, NULL, 0);
}
#endif
#ifdef __WIN32__
if (SDL_CPUCount <= 0) {
SYSTEM_INFO info;
GetSystemInfo(&info);
SDL_CPUCount = info.dwNumberOfProcessors;
}
#endif
#ifdef __OS2__
if (SDL_CPUCount <= 0) {
DosQuerySysInfo(QSV_NUMPROCESSORS, QSV_NUMPROCESSORS,
&SDL_CPUCount, sizeof(SDL_CPUCount) );
}
#endif
#endif
/* There has to be at least 1, right? :) */
if (SDL_CPUCount <= 0) {
SDL_CPUCount = 1;
}
}
return SDL_CPUCount;
}
size
GLsizeiptr size
Definition: SDL_opengl_glext.h:537
NULL
#define NULL
Definition: begin_code.h:164
SDL_CPUCount
static int SDL_CPUCount
Definition: SDL_cpuinfo.c:403

## SDL_GetCPUFeatures()

static Uint32 SDL_GetCPUFeatures | ( | void |  | ) |

static

Definition at line 576 of file SDL_cpuinfo.c.

References CPU_calcCPUIDFeatures(), CPU_HAS_3DNOW, CPU_HAS_ALTIVEC, CPU_HAS_AVX, CPU_HAS_AVX2, CPU_HAS_MMX, CPU_HAS_NEON, CPU_HAS_RDTSC, CPU_HAS_SSE, CPU_HAS_SSE2, CPU_HAS_SSE3, CPU_HAS_SSE41, CPU_HAS_SSE42, CPU_have3DNow(), CPU_haveAltiVec(), CPU_haveAVX, CPU_haveAVX2(), CPU_haveMMX, CPU_haveNEON(), CPU_haveRDTSC, CPU_haveSSE, CPU_haveSSE2, CPU_haveSSE3, CPU_haveSSE41, CPU_haveSSE42, and SDL_CPUFeatures.

{
if (SDL_CPUFeatures == 0xFFFFFFFF) {
CPU_calcCPUIDFeatures();
SDL_CPUFeatures = 0;
if (CPU_haveRDTSC()) {
SDL_CPUFeatures |= CPU_HAS_RDTSC;
}
if (CPU_haveAltiVec()) {
SDL_CPUFeatures |= CPU_HAS_ALTIVEC;
}
if (CPU_haveMMX()) {
SDL_CPUFeatures |= CPU_HAS_MMX;
}
if (CPU_have3DNow()) {
SDL_CPUFeatures |= CPU_HAS_3DNOW;
}
if (CPU_haveSSE()) {
SDL_CPUFeatures |= CPU_HAS_SSE;
}
if (CPU_haveSSE2()) {
SDL_CPUFeatures |= CPU_HAS_SSE2;
}
if (CPU_haveSSE3()) {
SDL_CPUFeatures |= CPU_HAS_SSE3;
}
if (CPU_haveSSE41()) {
SDL_CPUFeatures |= CPU_HAS_SSE41;
}
if (CPU_haveSSE42()) {
SDL_CPUFeatures |= CPU_HAS_SSE42;
}
if (CPU_haveAVX()) {
SDL_CPUFeatures |= CPU_HAS_AVX;
}
if (CPU_haveAVX2()) {
SDL_CPUFeatures |= CPU_HAS_AVX2;
}
if (CPU_haveNEON()) {
SDL_CPUFeatures |= CPU_HAS_NEON;
}
}
return SDL_CPUFeatures;
}
CPU_haveSSE2
#define CPU_haveSSE2()
Definition: SDL_cpuinfo.c:385
CPU_haveAVX
#define CPU_haveAVX()
Definition: SDL_cpuinfo.c:389
CPU_HAS_SSE41
#define CPU_HAS_SSE41
Definition: SDL_cpuinfo.c:86
CPU_HAS_RDTSC
#define CPU_HAS_RDTSC
Definition: SDL_cpuinfo.c:79
CPU_HAS_SSE3
#define CPU_HAS_SSE3
Definition: SDL_cpuinfo.c:85
CPU_calcCPUIDFeatures
static void CPU_calcCPUIDFeatures(void)
Definition: SDL_cpuinfo.c:251
CPU_HAS_SSE2
#define CPU_HAS_SSE2
Definition: SDL_cpuinfo.c:84
CPU_have3DNow
static int CPU_have3DNow(void)
Definition: SDL_cpuinfo.c:369
CPU_haveRDTSC
#define CPU_haveRDTSC()
Definition: SDL_cpuinfo.c:382
CPU_HAS_ALTIVEC
#define CPU_HAS_ALTIVEC
Definition: SDL_cpuinfo.c:80
CPU_haveMMX
#define CPU_haveMMX()
Definition: SDL_cpuinfo.c:383
CPU_haveAltiVec
static int CPU_haveAltiVec(void)
Definition: SDL_cpuinfo.c:290
CPU_HAS_AVX
#define CPU_HAS_AVX
Definition: SDL_cpuinfo.c:88
CPU_haveSSE42
#define CPU_haveSSE42()
Definition: SDL_cpuinfo.c:388
CPU_HAS_NEON
#define CPU_HAS_NEON
Definition: SDL_cpuinfo.c:90
CPU_haveSSE3
#define CPU_haveSSE3()
Definition: SDL_cpuinfo.c:386
SDL_CPUFeatures
static Uint32 SDL_CPUFeatures
Definition: SDL_cpuinfo.c:573
CPU_HAS_SSE
#define CPU_HAS_SSE
Definition: SDL_cpuinfo.c:83
CPU_haveAVX2
static int CPU_haveAVX2(void)
Definition: SDL_cpuinfo.c:392
CPU_HAS_AVX2
#define CPU_HAS_AVX2
Definition: SDL_cpuinfo.c:89
CPU_haveNEON
static int CPU_haveNEON(void)
Definition: SDL_cpuinfo.c:340
CPU_haveSSE
#define CPU_haveSSE()
Definition: SDL_cpuinfo.c:384
CPU_HAS_MMX
#define CPU_HAS_MMX
Definition: SDL_cpuinfo.c:81
CPU_haveSSE41
#define CPU_haveSSE41()
Definition: SDL_cpuinfo.c:387
CPU_HAS_SSE42
#define CPU_HAS_SSE42
Definition: SDL_cpuinfo.c:87
CPU_HAS_3DNOW
#define CPU_HAS_3DNOW
Definition: SDL_cpuinfo.c:82

## SDL_GetCPUType()

static const char* SDL_GetCPUType | ( | void |  | ) |

static

Definition at line 445 of file SDL_cpuinfo.c.

References CPU_calcCPUIDFeatures(), CPU_CPUIDMaxFunction, cpuid, d, i, SDL_strlcpy, and void.

Referenced by SDL_GetCPUCacheLineSize(), and SDL_GetSystemRAM().

{
static char SDL_CPUType[13];
if (!SDL_CPUType[0]) {
int i = 0;
CPU_calcCPUIDFeatures();
if (CPU_CPUIDMaxFunction > 0) { /* do we have CPUID at all? */
int a, b, c, d;
cpuid(0x00000000, a, b, c, d);
(void) a;
SDL_CPUType[i++] = (char)(b & 0xff); b >>= 8;
SDL_CPUType[i++] = (char)(b & 0xff); b >>= 8;
SDL_CPUType[i++] = (char)(b & 0xff); b >>= 8;
SDL_CPUType[i++] = (char)(b & 0xff);
SDL_CPUType[i++] = (char)(d & 0xff); d >>= 8;
SDL_CPUType[i++] = (char)(d & 0xff); d >>= 8;
SDL_CPUType[i++] = (char)(d & 0xff); d >>= 8;
SDL_CPUType[i++] = (char)(d & 0xff);
SDL_CPUType[i++] = (char)(c & 0xff); c >>= 8;
SDL_CPUType[i++] = (char)(c & 0xff); c >>= 8;
SDL_CPUType[i++] = (char)(c & 0xff); c >>= 8;
SDL_CPUType[i++] = (char)(c & 0xff);
}
if (!SDL_CPUType[0]) {
SDL_strlcpy(SDL_CPUType, "Unknown", sizeof(SDL_CPUType));
}
}
return SDL_CPUType;
}
SDL_strlcpy
#define SDL_strlcpy
Definition: SDL_dynapi_overrides.h:394
CPU_calcCPUIDFeatures
static void CPU_calcCPUIDFeatures(void)
Definition: SDL_cpuinfo.c:251
CPU_CPUIDMaxFunction
static int CPU_CPUIDMaxFunction
Definition: SDL_cpuinfo.c:247
d
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 SDL_AssertionHandler void SDL_SpinLock SDL_atomic_t int int return SDL_atomic_t return void void void return void return int return SDL_AudioSpec SDL_AudioSpec return int int return return int SDL_RWops int SDL_AudioSpec Uint8 ** d
Definition: SDL_dynapi_procs.h:117
c
const GLubyte * c
Definition: SDL_opengl_glext.h:11093
cpuid
#define cpuid(func, a, b, c, d)
Definition: SDL_cpuinfo.c:242
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
void
SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char int SDL_PRINTF_FORMAT_STRING const char const char SDL_SCANF_FORMAT_STRING const char return SDL_ThreadFunction const char void return Uint32 return Uint32 void
Definition: SDL_dynapi_procs.h:89
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
b
GLboolean GLboolean GLboolean b
Definition: SDL_opengl_glext.h:1109

## SDL_GetSystemRAM()

int SDL_GetSystemRAM | ( | void |  | ) |

This function returns the amount of RAM configured in the system, in MB.

Definition at line 697 of file SDL_cpuinfo.c.

References main, NULL, SDL_GetCPUCacheLineSize(), SDL_GetCPUCount(), SDL_GetCPUType(), SDL_Has3DNow(), SDL_HasAltiVec(), SDL_HasAVX(), SDL_HasAVX2(), SDL_HasMMX(), SDL_HasNEON(), SDL_HasRDTSC(), SDL_HasSSE(), SDL_HasSSE2(), SDL_HasSSE3(), SDL_HasSSE41(), SDL_HasSSE42(), and SDL_SystemRAM.

{
if (!SDL_SystemRAM) {
#ifndef SDL_CPUINFO_DISABLED
#if defined(HAVE_SYSCONF) && defined(_SC_PHYS_PAGES) && defined(_SC_PAGESIZE)
if (SDL_SystemRAM <= 0) {
SDL_SystemRAM = (int)((Sint64)sysconf(_SC_PHYS_PAGES) * sysconf(_SC_PAGESIZE) / (1024*1024));
}
#endif
#ifdef HAVE_SYSCTLBYNAME
if (SDL_SystemRAM <= 0) {
#if defined(__FreeBSD__) || defined(__FreeBSD_kernel__) || defined(__NetBSD__)
#ifdef HW_REALMEM
int mib[2] = {CTL_HW, HW_REALMEM};
#else
/* might only report up to 2 GiB */
int mib[2] = {CTL_HW, HW_PHYSMEM};
#endif /* HW_REALMEM */
#else
int mib[2] = {CTL_HW, HW_MEMSIZE};
#endif /* __FreeBSD__ || __FreeBSD_kernel__ */
Uint64 memsize = 0;
size_t len = sizeof(memsize);
if (sysctl(mib, 2, &memsize, &len, NULL, 0) == 0) {
SDL_SystemRAM = (int)(memsize / (1024*1024));
}
}
#endif
#ifdef __WIN32__
if (SDL_SystemRAM <= 0) {
MEMORYSTATUSEX stat;
stat.dwLength = sizeof(stat);
if (GlobalMemoryStatusEx(&stat)) {
SDL_SystemRAM = (int)(stat.ullTotalPhys / (1024 * 1024));
}
}
#endif
#ifdef __OS2__
if (SDL_SystemRAM <= 0) {
Uint32 sysram = 0;
DosQuerySysInfo(QSV_TOTPHYSMEM, QSV_TOTPHYSMEM, &sysram, 4);
SDL_SystemRAM = (int) (sysram / 0x100000U);
}
#endif
#endif
}
return SDL_SystemRAM;
}
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:181
SDL_SystemRAM
static int SDL_SystemRAM
Definition: SDL_cpuinfo.c:694
Uint64
uint64_t Uint64
Definition: SDL_stdinc.h:194
len
GLenum GLsizei len
Definition: SDL_opengl_glext.h:2926
NULL
#define NULL
Definition: begin_code.h:164
Sint64
int64_t Sint64
Definition: SDL_stdinc.h:188

## SDL_Has3DNow()

SDL_bool SDL_Has3DNow | ( | void |  | ) |

This function returns true if the CPU has 3DNow! features.

Definition at line 641 of file SDL_cpuinfo.c.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_3DNOW.

Referenced by SDL_GetSystemRAM().

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_3DNOW);
}
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:621
CPU_HAS_3DNOW
#define CPU_HAS_3DNOW
Definition: SDL_cpuinfo.c:82

## SDL_HasAltiVec()

SDL_bool SDL_HasAltiVec | ( | void |  | ) |

This function returns true if the CPU has AltiVec features.

Definition at line 629 of file SDL_cpuinfo.c.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_ALTIVEC.

Referenced by SDL_GetSystemRAM().

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_ALTIVEC);
}
CPU_HAS_ALTIVEC
#define CPU_HAS_ALTIVEC
Definition: SDL_cpuinfo.c:80
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:621

## SDL_HasAVX()

SDL_bool SDL_HasAVX | ( | void |  | ) |

This function returns true if the CPU has AVX features.

Definition at line 677 of file SDL_cpuinfo.c.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_AVX.

Referenced by SDL_GetSystemRAM().

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_AVX);
}
CPU_HAS_AVX
#define CPU_HAS_AVX
Definition: SDL_cpuinfo.c:88
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:621

## SDL_HasAVX2()

SDL_bool SDL_HasAVX2 | ( | void |  | ) |

This function returns true if the CPU has AVX2 features.

Definition at line 683 of file SDL_cpuinfo.c.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_AVX2.

Referenced by SDL_GetSystemRAM().

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_AVX2);
}
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:621
CPU_HAS_AVX2
#define CPU_HAS_AVX2
Definition: SDL_cpuinfo.c:89

## SDL_HasMMX()

SDL_bool SDL_HasMMX | ( | void |  | ) |

This function returns true if the CPU has MMX features.

Definition at line 635 of file SDL_cpuinfo.c.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_MMX.

Referenced by SDL_GetSystemRAM().

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_MMX);
}
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:621
CPU_HAS_MMX
#define CPU_HAS_MMX
Definition: SDL_cpuinfo.c:81

## SDL_HasNEON()

SDL_bool SDL_HasNEON | ( | void |  | ) |

This function returns true if the CPU has NEON (ARM SIMD) features.

Definition at line 689 of file SDL_cpuinfo.c.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_NEON.

Referenced by SDL_GetSystemRAM().

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_NEON);
}
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:621
CPU_HAS_NEON
#define CPU_HAS_NEON
Definition: SDL_cpuinfo.c:90

## SDL_HasRDTSC()

SDL_bool SDL_HasRDTSC | ( | void |  | ) |

This function returns true if the CPU has the RDTSC instruction.

Definition at line 623 of file SDL_cpuinfo.c.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_RDTSC.

Referenced by SDL_GetSystemRAM().

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_RDTSC);
}
CPU_HAS_RDTSC
#define CPU_HAS_RDTSC
Definition: SDL_cpuinfo.c:79
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:621

## SDL_HasSSE()

SDL_bool SDL_HasSSE | ( | void |  | ) |

This function returns true if the CPU has SSE features.

Definition at line 647 of file SDL_cpuinfo.c.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_SSE.

Referenced by SDL_GetSystemRAM().

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_SSE);
}
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:621
CPU_HAS_SSE
#define CPU_HAS_SSE
Definition: SDL_cpuinfo.c:83

## SDL_HasSSE2()

SDL_bool SDL_HasSSE2 | ( | void |  | ) |

This function returns true if the CPU has SSE2 features.

Definition at line 653 of file SDL_cpuinfo.c.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_SSE2.

Referenced by SDL_GetSystemRAM().

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_SSE2);
}
CPU_HAS_SSE2
#define CPU_HAS_SSE2
Definition: SDL_cpuinfo.c:84
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:621

## SDL_HasSSE3()

SDL_bool SDL_HasSSE3 | ( | void |  | ) |

This function returns true if the CPU has SSE3 features.

Definition at line 659 of file SDL_cpuinfo.c.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_SSE3.

Referenced by SDL_GetSystemRAM().

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_SSE3);
}
CPU_HAS_SSE3
#define CPU_HAS_SSE3
Definition: SDL_cpuinfo.c:85
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:621

## SDL_HasSSE41()

SDL_bool SDL_HasSSE41 | ( | void |  | ) |

This function returns true if the CPU has SSE4.1 features.

Definition at line 665 of file SDL_cpuinfo.c.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_SSE41.

Referenced by SDL_GetSystemRAM().

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_SSE41);
}
CPU_HAS_SSE41
#define CPU_HAS_SSE41
Definition: SDL_cpuinfo.c:86
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:621

## SDL_HasSSE42()

SDL_bool SDL_HasSSE42 | ( | void |  | ) |

This function returns true if the CPU has SSE4.2 features.

Definition at line 671 of file SDL_cpuinfo.c.

References CPU_FEATURE_AVAILABLE, and CPU_HAS_SSE42.

Referenced by SDL_GetSystemRAM().

{
return CPU_FEATURE_AVAILABLE(CPU_HAS_SSE42);
}
CPU_FEATURE_AVAILABLE
#define CPU_FEATURE_AVAILABLE(f)
Definition: SDL_cpuinfo.c:621
CPU_HAS_SSE42
#define CPU_HAS_SSE42
Definition: SDL_cpuinfo.c:87

## Variable Documentation

## CPU_CPUIDFeatures

int CPU_CPUIDFeatures[4]

static

Definition at line 246 of file SDL_cpuinfo.c.

Referenced by CPU_calcCPUIDFeatures().

## CPU_CPUIDMaxFunction

int CPU_CPUIDMaxFunction = 0

static

Definition at line 247 of file SDL_cpuinfo.c.

Referenced by CPU_calcCPUIDFeatures(), CPU_have3DNow(), CPU_haveAVX2(), and SDL_GetCPUType().

## CPU_OSSavesYMM

SDL_bool CPU_OSSavesYMM = SDL_FALSE

static

Definition at line 248 of file SDL_cpuinfo.c.

Referenced by CPU_calcCPUIDFeatures(), and CPU_haveAVX2().

## SDL_CPUCount

int SDL_CPUCount = 0

static

Definition at line 403 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUCount().

## SDL_CPUFeatures

Uint32 SDL_CPUFeatures = 0xFFFFFFFF

static

Definition at line 573 of file SDL_cpuinfo.c.

Referenced by SDL_GetCPUFeatures().

## SDL_SystemRAM

int SDL_SystemRAM = 0

static

Definition at line 694 of file SDL_cpuinfo.c.

Referenced by SDL_GetSystemRAM().